//=============================================================================
// Symbol.java  -  a tiny symbol table utility
//                 The symbol table contains <symbol type> pairs
//
// Author:  Bary W Pollack
// Date:    Apr. 17, 2004 - 16:00
//
//=============================================================================

import java.util.*;

public class Symbol extends TreeMap {
    public static final char VARIABLE = 'V';
    public static final char ARRAYREF = 'A';
    public static final char FUNCTION = 'F';
    public static final char INTEGER  = 'N';

    Symbol() { }

    Symbol(String sName, char cKind) {
        this.sName = sName;  this.cKind = cKind;
    }

    public String toString() {
        return "<" + sName + " " + cKind + ">";
    }

    public boolean check(String sSymbol, String sMsg) {
        boolean bCheck = false;
        if (get(sSymbol) == null) {
            System.out.println(sMsg);
            bCheck = true;
        }
        return bCheck;
    }

    public void displaySymbols() {
        System.out.println("Symbol Table (" + size() + " entries)");
        int n = 1;
        Set set = entrySet();
        for (Iterator i = set.iterator(); i.hasNext(); n++) {
            Map.Entry e = (Map.Entry) i.next();
            String s = ((String)e.getKey()) + "        ";
            System.out.print("   " + (n + "    ").substring(0,3));
            System.out.print("  " + s.substring(0, 8) + " ");
            System.out.println((Symbol)e.getValue());
        }
    }

    private String sName;            // the symbol
    private char   cKind;            // the kind
}
